-- registr_en.vhd: register with enable signal
-- Author: Lucie Matusova, xmatus21

library IEEE;
use IEEE.std_logic_1164.all;

-- ----------------------------------------------------------------------------
--                        Entity declaration
-- ----------------------------------------------------------------------------

entity registr_en is
  generic ( 
    n : natural 
  );  
  port (
    CLK : in std_logic;
    RST : in std_logic;
    EN  : in std_logic;
    I   : in std_logic_vector (n-1 downto 0);
    O   : out std_logic_vector(n-1 downto 0) 
  );
end registr_en;      

-- ----------------------------------------------------------------------------
--                      Architecture declaration
-- ----------------------------------------------------------------------------

architecture behv of registr_en is
  signal R : std_logic_vector(n-1 downto 0);
begin

  process (CLK, RST, I, EN)
  begin
   
    if (CLK='1') and (CLK'event) then
      if (RST='1') then
        R <= (others => '0');
      elsif (EN = '1') then
        R <= I;
      end if;
    end if;  

  end process;
  
  O <= R;

-- ---------------------------------------------------------------------------          
end behv;