library ieee;
use ieee.std_logic_1164.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 20 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  -- prepajacie signaly
  signal clk         : std_logic;
  signal rst         : std_logic;
  signal act         : std_logic;
  signal s_0         : std_logic_vector(data_width-1 downto 0);  
  signal s_1         : std_logic_vector(data_width-1 downto 0);  
  signal s_2         : std_logic_vector(data_width-1 downto 0);  
  signal s_3         : std_logic_vector(data_width-1 downto 0);  
  signal output      : std_logic_vector(data_width-1 downto 0);
  signal vld         : std_logic;

begin
  -- instancia testovanej komponenty
  UUT : entity work.BDU_ENT
  port map( CLK         => clk,
            RST         => rst,
            ACT         => act,
            S_0         => s_0,
            S_1         => s_1,
            S_2         => s_2,
            S_3         => s_3,
            OUTPUT      => output,
            VLD         => vld

  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for reset_time;
      rst   <= '0';
      wait for 20*clk_period;
      rst   <= '1';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    act        <= '0';
    s_0        <= "0000000000000000";
    s_1        <= "0000000000000000";
    s_2        <= "0000000000000000";
    s_3        <= "0000000000000000";
    
    act        <= '0';
    wait for 6*clk_period;
    s_0        <= "0000000000000001";
    s_1        <= "0000000000000010";
    s_2        <= "0000000000001000";
    s_3        <= "0000000000000100";
    wait for 2*clk_period;
    act        <= '1';
    wait for 3*clk_period+10 ns;
    act        <= '0';
    
    wait for 3*clk_period;
    s_0        <= "0000000000000010";
    s_1        <= "0000000000000100";
    s_2        <= "0000000000001000";
    s_3        <= "0000000000010000";
    wait for 7*clk_period;
    act        <= '1';
    wait for 5*clk_period;
    act        <= '0';
    wait;
  end process behaviour; 
   
end architecture tb_arch;
