library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 20 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  -- prepajacie signaly
  signal clk         : std_logic;
  signal rst         : std_logic;  
  signal l           : std_logic;
  signal r           : std_logic;
  signal t           : std_logic;
  signal b           : std_logic;
  signal x           : std_logic_vector(data_width - 1 downto 0);
  signal y           : std_logic_vector(data_width - 1 downto 0);
  signal fifo_act    : std_logic;
  signal fifo_vld    : std_logic;
  signal act         : std_logic;
  signal vld         : std_logic;
      

begin
  -- instancia testovanej komponenty
  UUT : entity work.ECU_FSM_ENT
  port map( CLK         => clk,
            RST         => rst,
            L           => l,
            R           => r,
            T           => t,
            B           => b,
            FIFO_ACT    => fifo_act,
            FIFO_VLD    => fifo_vld,
            X           => x,
            Y           => y,
            ACT         => act,
            VLD         => vld
  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for reset_time;
      rst   <= '0';
      --wait for 10*reset_time;
      --rst   <= '1';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    fifo_vld <= '0';
    vld <= '0';
    x        <= std_logic_vector(to_unsigned(0, DATA_WIDTH));
    y        <= std_logic_vector(to_unsigned(0, DATA_WIDTH));
    wait for reset_time;
    wait for reset_time;
    wait for clk_period;
    fifo_vld <= '1';
    x        <= std_logic_vector(to_unsigned(1, DATA_WIDTH));
    y        <= std_logic_vector(to_unsigned(6, DATA_WIDTH));
    wait for clk_period;
    fifo_vld <= '0';
    wait for reset_time;
    fifo_vld <= '1';
    x        <= std_logic_vector(to_unsigned(1, DATA_WIDTH));
    y        <= std_logic_vector(to_unsigned(5, DATA_WIDTH));
    wait for clk_period;
    fifo_vld <= '0';
    wait for reset_time;
    vld <= '1';
    wait for clk_period;
    vld <= '0';
    
    wait for 2*clk_period;
    fifo_vld <= '1';
    x        <= std_logic_vector(to_unsigned(2, DATA_WIDTH));
    y        <= std_logic_vector(to_unsigned(5, DATA_WIDTH));
    wait for clk_period;
    fifo_vld <= '0';
    wait for reset_time;
    vld <= '1';
    wait for clk_period;
    vld <= '0';
    wait;
  end process behaviour; 
   
end architecture tb_arch;
