library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 20 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  -- prepajacie signaly
  signal clk            : std_logic;
  signal rst            : std_logic;  
      -- ----------------- input interface --------------------------------
  signal x_in           : std_logic_vector(data_width - 1 downto 0);
  signal y_in           : std_logic_vector(data_width - 1 downto 0);
  signal vld_in         : std_logic;
  signal act_in         : std_logic;
      -- ----------------- output interface -------------------------
  signal x_out          : std_logic_vector(data_width - 1 downto 0);
  signal y_out          : std_logic_vector(data_width - 1 downto 0);
  signal vld_out        : std_logic;
  signal act_out        : std_logic;   

begin
  -- instancia testovanej komponenty
  UUT : entity work.QUEUE_ENT
  port map( CLK            => clk,
            RST            => rst,
            -- ----------------- INPUT INTERFACE --------------------------------
            X_IN           => x_in,
            Y_IN           => y_in,
            VLD_IN         => vld_in,
            ACT_IN         => act_in,
            -- ----------------- OUTPUT INTERFACE -------------------------
            X_OUT          => x_out,
            Y_OUT          => y_out,
            VLD_OUT        => vld_out,
            ACT_OUT        => act_out
  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for reset_time;
      rst   <= '0';
      --wait for 10*reset_time;
      --rst   <= '1';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    act_out <= '0';
    act_in <= '0';
    x_in        <= std_logic_vector(to_unsigned(0, DATA_WIDTH));
    y_in        <= std_logic_vector(to_unsigned(0, DATA_WIDTH));
    wait for reset_time;
    wait for reset_time;
    wait for clk_period;
    act_in <= '1';
    x_in        <= std_logic_vector(to_unsigned(12, DATA_WIDTH));
    y_in        <= std_logic_vector(to_unsigned(13, DATA_WIDTH));
    wait for 2*clk_period;
    act_in <= '0';
    
    wait for reset_time;
    act_in <= '1';
    x_in        <= std_logic_vector(to_unsigned(12, DATA_WIDTH));
    y_in        <= std_logic_vector(to_unsigned(13, DATA_WIDTH));
    wait for 2*clk_period;
    act_in <= '0';
    
    wait for reset_time;
    act_in <= '1';
    x_in        <= std_logic_vector(to_unsigned(46, DATA_WIDTH));
    y_in        <= std_logic_vector(to_unsigned(54, DATA_WIDTH));
    wait for 2*clk_period;
    
    --act_in <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for 2*clk_period;
    act_in <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';

    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait for reset_time;
    act_out <= '1';
    wait for 2*clk_period;
    --act_out <= '0';
    
    wait for reset_time;
    act_in <= '1';
    x_in        <= std_logic_vector(to_unsigned(43, DATA_WIDTH));
    y_in        <= std_logic_vector(to_unsigned(21, DATA_WIDTH));
    wait for 2*clk_period;
    act_in <= '0';
    wait for 2*clk_period;
    act_out <= '0';
    
    wait;
  end process behaviour; 
   
end architecture tb_arch;
