library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 30 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  -- prepajacie signaly
  signal clk         : std_logic;
  signal rst         : std_logic;  
  signal x_speed     : std_logic_vector(data_width - 1 downto 0);
  signal y_speed     : std_logic_vector(data_width - 1 downto 0);
  signal act_in      : std_logic;
  signal vld_in      : std_logic;
  signal x_in        : std_logic_vector(data_width - 1 downto 0);
  signal y_in        : std_logic_vector(data_width - 1 downto 0);
      

begin
  -- instancia testovanej komponenty
  UUT : entity work.ECU_ENT
  port map( CLK         => clk,
            RST         => rst,
            ACT_IN      => act_in,
            VLD_IN      => vld_in,
            X_IN        => x_in,
            Y_IN        => y_in,
            X_SPEED     => x_speed,
            Y_SPEED     => y_speed
  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for reset_time;
      rst   <= '0';
      --wait for 10*reset_time;
      --rst   <= '1';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    act_in <= '0';
    x_in        <= std_logic_vector(to_unsigned(0, DATA_WIDTH));
    y_in        <= std_logic_vector(to_unsigned(0, DATA_WIDTH));
    wait for 10*reset_time;
    
    act_in <= '1';
    x_in        <= std_logic_vector(to_unsigned(5, DATA_WIDTH));
    y_in        <= std_logic_vector(to_unsigned(1, DATA_WIDTH));
    wait for 2*clk_period;
    act_in <= '0';
    wait for 2*clk_period;
    act_in <= '1';
    x_in        <= std_logic_vector(to_unsigned(5, DATA_WIDTH));
    y_in        <= std_logic_vector(to_unsigned(1, DATA_WIDTH));
    wait for 2*clk_period;
    act_in <= '0';
    wait for 2*clk_period;
    act_in <= '1';
    x_in        <= std_logic_vector(to_unsigned(5, DATA_WIDTH));
    y_in        <= std_logic_vector(to_unsigned(2, DATA_WIDTH));
    wait for 2*clk_period;
    act_in <= '0';
    
    wait for reset_time;
    wait for clk_period;

    wait;
  end process behaviour; 
   
end architecture tb_arch;
