library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 20 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  -- prepajacie signaly
  signal clk         : std_logic;
  signal rst         : std_logic;
  signal act         : std_logic;
  signal dist_A      : std_logic_vector(data_width-1 downto 0);  
  signal dist_B      : std_logic_vector(data_width-1 downto 0);  
  signal dist_C      : std_logic_vector(data_width-1 downto 0);  
  signal x           : std_logic_vector(data_width-1 downto 0);
  signal y           : std_logic_vector(data_width-1 downto 0);
  signal vld         : std_logic;

begin
  -- instancia testovanej komponenty
  UUT : entity work.PEU_ENT
  port map( CLK         => clk,
            RST         => rst,
            ACT         => act,
            DIST_A      => dist_a,
            DIST_B      => dist_b,
            DIST_C      => dist_c,
            X           => x,
            Y           => y,
            VLD         => vld

  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for reset_time;
      rst   <= '0';
      wait for 20*clk_period;
      rst   <= '1';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    act        <= '0';
    dist_a     <= "0000000000000000"; --"0000000000000001"; --
    dist_b     <= "0000000000000000";
    dist_c     <= "0000000000000000";
    
    act        <= '0';
    wait for 6*clk_period;
    dist_a     <= "0000000000110011"; --"0000000000000001"; --
    wait for clk_period;
    dist_b     <= "0000000000101101";
    wait for clk_period;
    dist_c     <= "0000000000100110";
    wait for 2*clk_period;
    act        <= '1';
    wait for 3*clk_period+10 ns;
    act        <= '0';
    
    wait for 3*clk_period;
    dist_a     <= std_logic_vector(to_unsigned(56, DATA_WIDTH));
    wait for clk_period;
    dist_b     <= std_logic_vector(to_unsigned(68, DATA_WIDTH));
    wait for clk_period;
    dist_c     <= std_logic_vector(to_unsigned(46, DATA_WIDTH));
    wait for 3*clk_period;
    act        <= '1';
    wait for 5*clk_period;
    act        <= '0';
    wait;
  end process behaviour; 
   
end architecture tb_arch;
