library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 20 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  -- prepajacie signaly
  signal clk            : std_logic;
  signal rst            : std_logic;
      
      -- ----------------- INPUT DATA --------------------------------- 
  signal a              : std_logic_vector(data_width-1 downto 0);
  signal b              : std_logic_vector(data_width-1 downto 0);
  signal c              : std_logic_vector(data_width-1 downto 0);

  signal not_cyc_write  : std_logic;
              
      -- ----------------- output data ---------------------------
  signal x              : std_logic_vector(data_width-1 downto 0);
  signal y              : std_logic_vector(data_width-1 downto 0);
      

begin
  -- instancia testovanej komponenty
  UUT : entity work.PEU_FSM_TL_ENT
  port map( CLK            => clk,
            RST            => rst,
            -- ----------------- INPUT DATA --------------------------------- 
            A              => a,
            B              => b,
            C              => c,

            NOT_CYC_WRITE  => not_cyc_write,
            -- ----------------- OUTPUT DATA ---------------------------
            X              => x,
            Y              => y         
  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for reset_time;
      rst   <= '0';
      wait for 20*clk_period;
      rst   <= '0';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    a                <= "0000000000000000"; --"0000000000000000"; --
    b                <= "0000000000000000";
    c                <= "0000000000000000";
  
    not_cyc_write    <= '0';
    wait for reset_time;
    a                <= "0000000000110011"; --"0000000000000001"; --
    b                <= "0000000000101101";
    c                <= "0000000000100110";
    wait for 2*clk_period;
    not_cyc_write    <= '1';
    wait for reset_time;
    wait for 2*clk_period;
    not_cyc_write    <= '0';
    wait for clk_period;
    a                <= "0000000000100110"; --"0000000000000001"; --
    wait for clk_period;
    b                <= "0000000000101101";
    wait for clk_period;
    wait for clk_period;
    c                <= "0000000000110011";
    not_cyc_write    <= '1';
    
    wait;
  end process behaviour; 
   
end architecture tb_arch;
