library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity testbench is
end entity testbench;

architecture tb_arch of testbench is
  -- perioda hodin 
  constant clk_period   : time := 35 ns;
  constant reset_time   : time := 100 ns;
  constant data_width   : integer := 16;
  
  signal clk               : std_logic;
  signal rst               : std_logic;
  
  signal dist_a          : std_logic_vector(data_width-1 downto 0);
  signal dist_b          : std_logic_vector(data_width-1 downto 0);
  signal dist_c          : std_logic_vector(data_width-1 downto 0);
  signal s_0             : std_logic_vector(data_width-1 downto 0);
  signal s_1             : std_logic_vector(data_width-1 downto 0);
  signal s_2             : std_logic_vector(data_width-1 downto 0);
  signal s_3             : std_logic_vector(data_width-1 downto 0);
  signal data_vld        : std_logic; 
  
  signal x_speed         : std_logic_vector(data_width-1 downto 0);
  signal y_speed         : std_logic_vector(data_width-1 downto 0);
  
  --PFU_READ_MASTER
  --signal pfu_act         : std_logic;
  --signal pfu_vld         : std_logic;
  --signal pfu_x           : std_logic_vector( 15 downto 0 );
  --signal pfu_y           : std_logic_vector( 15 downto 0 );
  
  --signal addr_x          : std_logic_vector(15 downto 0);
  --signal addr_y          : std_logic_vector(15 downto 0);
  --signal data_out        : std_logic_vector(3 downto 0);
      

begin
  -- instancia testovanej komponenty
  UUT : entity work.ROBOT_CONTROLLER_ENT
  port map( 
      CLK               => clk,
      RST               => rst,
      DIST_A            => dist_a,
      DIST_B            => dist_b,
      DIST_C            => dist_c,
      S_0               => s_0,
      S_1               => s_1,
      S_2               => s_2,
      S_3               => s_3,
      DATA_VLD          => data_vld,
      X_SPEED           => x_speed,
      Y_SPEED           => y_speed
      --PFU_ACT           => pfu_act,
      --PFU_VLD           => pfu_vld, 
      --PFU_X             => pfu_x,
      --PFU_Y             => pfu_y,
      --ADDR_X            => addr_x,
      --ADDR_Y            => addr_y,
      --DATA_OUT          => data_out
  );

  -- generovanie hodinoveho signalu 
  clk_gen :  process 
  begin  
    clk     <='1';
    wait for clk_period/2;
    clk     <='0';
    wait for clk_period/2;
  end process clk_gen;
  
  resetgen: process
   begin
      rst   <= '1';
      wait for 3*reset_time;
      rst   <= '0';
      
      wait for 2*reset_time;
      --rst_i   <= '1';
      wait for clk_period;
      rst   <= '0';
      wait;
   end process;

  -- generovanie vstupov
  behaviour : process
  begin
    data_vld <= '0';
    --wait for 10*reset_time; 	
	--wait for 10*reset_time; 
	--data_vld <= '1';
    -- 1,6
	--wait for 10*reset_time;
    
    wait for 10*reset_time;
	data_vld <= '1';
	wait for 10*reset_time;
	data_vld <= '0';
	wait for 25*reset_time;
	dist_a  <= std_logic_vector(to_unsigned(17, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(53, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(74, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(12, DATA_WIDTH));
	wait for 5*reset_time;
	data_vld <= '1';
    wait for 20*reset_time; 
    --1,5
    dist_a  <= std_logic_vector(to_unsigned(23, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(46, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(68, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(28, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(12, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    wait for 20*reset_time; 
	--data_vld <= '0';
    --2,5
    dist_a  <= std_logic_vector(to_unsigned(28, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(48, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(62, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(12, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(20, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    wait for 40*reset_time; 
	data_vld <= '1';
    --3,5
    dist_a  <= std_logic_vector(to_unsigned(34, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(52, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(57, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(20, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(12, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(4, DATA_WIDTH)); 
    wait for 20*reset_time;     
    --4,5
    dist_a  <= std_logic_vector(to_unsigned(41, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(57, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(52, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(28, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(12, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(36, DATA_WIDTH));  
    wait for 30*reset_time;    
    --4,6
    dist_a  <= std_logic_vector(to_unsigned(38, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(63, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(59, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(20, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(44, DATA_WIDTH)); 
    wait for 30*reset_time;
    --5,6
    dist_a  <= std_logic_vector(to_unsigned(46, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(68, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(56, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(12, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(12, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));  
    wait for 30*reset_time;
    --6,6
    dist_a  <= std_logic_vector(to_unsigned(53, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(74, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(53, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(20, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(44, DATA_WIDTH));  
    wait for 30*reset_time;
    --6,5
    dist_a  <= std_logic_vector(to_unsigned(56, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(68, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(46, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(12, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(36, DATA_WIDTH));  
    wait for 30*reset_time;
    --6,4
    dist_a  <= std_logic_vector(to_unsigned(59, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(63, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(38, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(20, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(28, DATA_WIDTH));  
    wait for 30*reset_time;
    --6,3
    dist_a  <= std_logic_vector(to_unsigned(63, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(59, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(30, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(28, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(20, DATA_WIDTH));  
    wait for 30*reset_time;    
    --6,2
    dist_a  <= std_logic_vector(to_unsigned(68, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(56, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(23, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(36, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(12, DATA_WIDTH));    
    wait for 30*reset_time;    
    --6,1
    dist_a  <= std_logic_vector(to_unsigned(74, DATA_WIDTH));
    dist_b  <= std_logic_vector(to_unsigned(53, DATA_WIDTH));
    dist_c  <= std_logic_vector(to_unsigned(17, DATA_WIDTH));
    s_0     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_1     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));
    s_2     <= std_logic_vector(to_unsigned(44, DATA_WIDTH));
    s_3     <= std_logic_vector(to_unsigned(4, DATA_WIDTH));      
    wait for 30*reset_time;
    wait;
  end process behaviour; 
  
  -- generovanie vstupov
  behaviour2 : process
  begin
    --addr_x <= std_logic_vector(to_unsigned(1, DATA_WIDTH));
    --addr_y <= std_logic_vector(to_unsigned(6, DATA_WIDTH));
    --pfu_act <= '0';  
    --wait for 2*reset_time;
    --wait for 40*clk_period;
    --pfu_act <= '1';
    --wait for 7*clk_period;
    --pfu_act <= '0';
    wait;
  end process behaviour2;
 
end architecture tb_arch;
